<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Benchmark Library</h1>

		<p>CarbonPHP has a benchmark library that is always active, this library enables you to make the time
		between two points. <i>Note</i>: the benchmark library is automatically loaded by CarbonPHP so there is no
		need for you to load it.</p>

		<p>The benchmark library is always started the moment the framework is invoked, and ended once the output
		class is ready to send the final data to the browser.  This means a very accurate value for the time the
		system took to execute.</p>
	</div>

	<div class="content">
		<h1>Using the Benchmark Library</h1>

		<p>The benchmark library can be used within, models, views, or controllers.  The process of using the library
		is as follows.</p>

		<ol>
			<li>Mark the start point.</li>
			<li>Mark the end point.</li>
			<li>Run the <b>elapsed_time()</b> function to view the result.</li>
		</ol>

		<p>A simple example of using the benchmark library is shown below.</p>

		<div class="example">
			$this->benchmark->mark('code_start');<br />
			<br />
			// Some code executes here...<br />
			<br />
			$this->benchmark->mark('code_end');<br />
			<br />
			echo $this->benchmark->elapsed_time('code_start', 'code_end');
		</div>

		<p><i>Note</i>: the marker words <b>code_start</b> and <b>code_end</b> can be any words of your choosing.
		See the follow example.</p>

		<div class="example">
			$this->benchmark->mark('cow');<br />
			<br />
			// Some code executes here...<br />
			<br />
			$this->benchmark->mark('duck');<br />
			<br />
			// Some more code executes here...<br />
			<br />
			$this->benchmark->mark('sheep');<br />
			<br />
			echo  $this->benchmark->elapsed_time('cow', 'duck');<br />
			echo  $this->benchmark->elapsed_time('duck', 'sheep');<br />
			echo  $this->benchmark->elapsed_time('cow', 'sheep');
		</div>
	</div>

	<div class="content">
		<h1>Displaying Total CarbonPHP Execution Time</h1>

		<p>If you wish to display the total time it took the framework the execute.  You can simply place the following
		method call into your view.</p>

		<div class="example">
			&lt;?php echo $this->benchmark->elapsed_time(); ?&gt;
		</div>

		<p>You will notice that the above code uses the same method as calculating the time between two mark points,
		except there are no parameters passed to the method.  An alternate way to show the total framework elapsed
		time is to include the psuedo-variable <b>{elapsed_time}</b> in your view if you do not wish to use the
		pure PHP code.</p>

		<div class="example">
			{elapsed_time}
		</div>
	</div>

	<div class="content">
		<h1>Displaying CarbonPHP Memory Usage</h1>

		<p>If your PHP installation is setup with the <b>--enable-memory-limit</b> configuration option, you can
		display the memory that CarbonPHP is using.  To do this you can use the following line of code.</p>

		<div class="example">
			&lt;?php echo $this->benchmark->memory_usage(); ?&gt;
		</div>

		<p><i>Note</i>: if you wish to use this method, it can only be used in your view files.  The memory usage
		shown by this method will display the amount of memory used by the entire application.  You can also use a
		psuedo-variable to display the memory usage, just like elapsed time.</p>

		<div class="example">
			{memory_usage}
		</div>
	</div>
</body>

</html>
